/////////////////////////////////////////////////////////////////////////////
//	Author			:	Bala Murali
//	TcpClientDlg.cpp:	implementation file
//	Creation Date	:	03/09/2000
//	Version			:	Initial Release
/////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "TcpClient.h"
#include "TcpClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpClientDlg dialog

CTcpClientDlg::CTcpClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTcpClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTcpClientDlg)
	m_HostName = _T("");
	m_Port = 7;
	m_Message = _T("");
	m_ReceivedData = _T("");
	m_ReceivedBuffSize = 4096;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTcpClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTcpClientDlg)
	DDX_Text(pDX, IDC_HOSTNAME, m_HostName);
	DDX_Text(pDX, IDC_PORT, m_Port);
	DDX_Text(pDX, IDC_MESSAGE, m_Message);
	DDX_Text(pDX, IDC_RECEIVEDATA, m_ReceivedData);
	DDX_Text(pDX, IDC_BUFFSIZE, m_ReceivedBuffSize);
	DDV_MinMaxLong(pDX, m_ReceivedBuffSize, 1, 8192);
	DDX_Control(pDX, IDC_XSOCKCLIENTCTRL1, m_Client);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTcpClientDlg, CDialog)
	//{{AFX_MSG_MAP(CTcpClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_EN_KILLFOCUS(IDC_BUFFSIZE, OnKillfocusBuffsize)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTcpClientDlg message handlers

BOOL CTcpClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	GetDlgItem(IDC_CONNECT)->EnableWindow();
	GetDlgItem(IDC_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTcpClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTcpClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTcpClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CTcpClientDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CTcpClientDlg)
	ON_EVENT(CTcpClientDlg, IDC_XSOCKCLIENTCTRL1, 5 /* OnReceive */, OnOnReceiveXsockclientctrl1, VTS_BSTR VTS_I4)
	ON_EVENT(CTcpClientDlg, IDC_XSOCKCLIENTCTRL1, 1 /* OnConnect */, OnOnConnectXsockclientctrl1, VTS_NONE)
	ON_EVENT(CTcpClientDlg, IDC_XSOCKCLIENTCTRL1, 2 /* OnClose */, OnOnCloseXsockclientctrl1, VTS_NONE)
	ON_EVENT(CTcpClientDlg, IDC_XSOCKCLIENTCTRL1, 3 /* OnSend */, OnOnSendXsockclientctrl1, VTS_NONE)
	ON_EVENT(CTcpClientDlg, IDC_XSOCKCLIENTCTRL1, 4 /* OnError */, OnOnErrorXsockclientctrl1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CTcpClientDlg::OnOnReceiveXsockclientctrl1(LPCTSTR Data, long nLen) 
{
	UpdateData(TRUE);
	m_ReceivedData += Data;
	UpdateData(FALSE);
}

void CTcpClientDlg::OnOnConnectXsockclientctrl1() 
{
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLOSE)->EnableWindow();
}

void CTcpClientDlg::OnOnCloseXsockclientctrl1() 
{
	GetDlgItem(IDC_CONNECT)->EnableWindow();
	GetDlgItem(IDC_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
}

void CTcpClientDlg::OnOnSendXsockclientctrl1() 
{
	GetDlgItem(IDC_SEND)->EnableWindow();	
}

void CTcpClientDlg::OnClose() 
{
	m_Client.Close();
	GetDlgItem(IDC_CONNECT)->EnableWindow();
	GetDlgItem(IDC_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
}

void CTcpClientDlg::OnConnect() 
{
	UpdateData(TRUE);
	if ( m_HostName.IsEmpty() )
		return;

	m_Client.Connect(m_HostName,m_Port);
	UpdateData(FALSE);
}

void CTcpClientDlg::OnKillfocusBuffsize() 
{
	m_Client.SetReceiveBufferCount(m_ReceivedBuffSize);
}

void CTcpClientDlg::OnOnErrorXsockclientctrl1(LPCTSTR lpErrorDescription) 
{
	GetDlgItem(IDC_CONNECT)->EnableWindow();
	GetDlgItem(IDC_SEND)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLOSE)->EnableWindow(FALSE);
}

void CTcpClientDlg::OnSend() 
{
	UpdateData(TRUE);
	int nDataLen = m_Message.GetLength(); 
	m_Client.Send(m_Message, nDataLen);
	UpdateData(TRUE);
}
