/////////////////////////////////////////////////////////////////////////////
//	Author				:	Bala Murali
//	XEchoServerDlg.cpp	:	implementation file
//	Creation Date		:	03/09/2000
//	Version				:	Initial Release
/////////////////////////////////////////////////////////////////////////////




#include "stdafx.h"
#include "XEchoServer.h"
#include "XEchoServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXEchoServerDlg dialog

CXEchoServerDlg::CXEchoServerDlg(CWnd* pParent /*=NULL*/)
: CDialog(CXEchoServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXEchoServerDlg)
	m_EchoString = _T("");
	m_nConnections = 0;
	m_ErrorStatus = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nConnections = 0;
	m_AttachStatus[0] = FALSE;
	m_AttachStatus[1] = FALSE;
}

void CXEchoServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXEchoServerDlg)
	DDX_Text(pDX, IDC_EDIT1, m_EchoString);
	DDX_Control(pDX, IDC_XSOCKSERVERCTRL1, m_server1);
	DDX_Text(pDX, IDC_EDIT2, m_nConnections);
	DDX_Text(pDX, IDC_STATUS, m_ErrorStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXEchoServerDlg, CDialog)
	//{{AFX_MSG_MAP(CXEchoServerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXEchoServerDlg message handlers

BOOL CXEchoServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	// Set your local address here, else default local address and local port is taken
//	m_server1.SetLocalAddress("xx.yy.zz.zz");	
	m_server1.SetLocalPort(7);
	if ( !m_server1.Listen() )
	{
		AfxMessageBox("Echo Server Failed to Listen.",MB_ICONSTOP);
//		PostQuitMessage(WM_QUIT);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CXEchoServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CXEchoServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXEchoServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CXEchoServerDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CXEchoServerDlg)
	ON_EVENT(CXEchoServerDlg, IDC_XSOCKSERVERCTRL1, 4 /* OnAccept */, OnOnAcceptXsockserverctrl1, VTS_I4)
	ON_EVENT(CXEchoServerDlg, IDC_XSOCKSERVERCTRL1, 1 /* OnError */, OnOnErrorXsockserverctrl1, VTS_BSTR)
	ON_EVENT(CXEchoServerDlg, IDC_XSOCKSERVERCTRL1, 3 /* OnReceive */, OnOnReceiveXsockserverctrl1, VTS_I4 VTS_BSTR VTS_I4)
	ON_EVENT(CXEchoServerDlg, IDC_XSOCKSERVERCTRL1, 2 /* OnClose */, OnOnCloseXsockserverctrl1, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CXEchoServerDlg::OnOnAcceptXsockserverctrl1(long lChildId) 
{
	UpdateData(TRUE);
	m_nConnections++;
	UpdateData(FALSE);
}

void CXEchoServerDlg::OnOnErrorXsockserverctrl1(LPCTSTR lpErrorDescription) 
{
	UpdateData(TRUE);
	m_ErrorStatus  = "Error: ";
	m_ErrorStatus  =+ lpErrorDescription;
	UpdateData(FALSE);
	
}

void CXEchoServerDlg::OnOnReceiveXsockserverctrl1(long lChildId, LPCTSTR lpData, long lDataLen) 
{
	UpdateData(TRUE);
	m_EchoString += lpData;
	m_server1.Send( lChildId, lpData, lDataLen);
	UpdateData(FALSE);	
	
}

void CXEchoServerDlg::OnOnCloseXsockserverctrl1(long lChildId) 
{
	UpdateData(TRUE);
	m_nConnections--;
	UpdateData(FALSE);
}
